#include <bits/stdc++.h>

using namespace std;

vector<string> getTokens(string& s, char delim) {
    if (s.empty()) return {};

    vector<string> tokens(1);
    for (char c: s) {
        if (c == delim) tokens.push_back("");
        else tokens.back().push_back(c);
    }
    return tokens;
}

bool isInt(string& s) {
    if (s.size() == 0) return false;
    if (s.size() >= 10) return false;
    for (char c: s) {
        if (!isdigit(c)) return false;
    }
    return true;
}

int toInt(string& s) {
    int ans = 0;
    for (char c: s) {
        ans = 10*ans+c-'0';
    }
    return ans;
}

void finish(bool ok1, bool ok2, int n, string message) {
    if (n <= 5) {
        if (ok1 && ok2) cout << 1 << endl;
        else cout << 0 << endl;
    } else {
        if (ok1 && ok2) cout << 1 << endl;
        else if (ok1) cout << 0.75 << endl;
        else cout << 0 << endl;
    }

    if (message.size()) cerr << message << endl;
    exit(0);
}

int main(int argc, char *argv[]) {
    ifstream in(argv[1]);
    ifstream sol(argv[2]);
    ifstream out(argv[3]);

    if (!in) {
        finish(0, 0, 0, "In-файл "+string(argv[1])+" не е намерен.");
    }
    if (!sol) {
        finish(0, 0, 0, "Sol-файл "+string(argv[2])+" не е намерен.");
    }
    if (!out) {
        finish(0, 0, 0, "Out-файл "+string(argv[3])+" не е намерен.");
    }

    int n; in >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) in >> v[i].first >> v[i].second;

    string message;
    if (n <= 5) message += "n <= 5\n";
    else message += "n > 5\n";


    string solAns1, outAns1;
    int solAns, outAns;
    sol >> solAns1;
    if (!(out >> outAns1)) {
        message += "Липсва броя разговори\n";
        finish(0, 0, n, message);
    }

    if (solAns1 != outAns1)
    {
        message += "Грешен отговор\n";
        finish(0, 0, n, message);
    }

    if (solAns1 == outAns1 && solAns1 == "Impossible!")
    {
        message += "Верен отговор\n";
        finish(1, 1, n, message);
    }

    solAns = toInt(solAns1);
    outAns = toInt(outAns1);
    if (solAns == outAns) message += "Верен брой разговори\n";
    else message += "Грешен брой разговори\n";

    if (solAns != outAns) {
        finish(0, 0, n, message);
    }

    if (solAns == 0)
    {
        message += "Верен списък с апартаменти";
        finish(1, 1, n, message);
    }

    string s;
    if (!getline(out, s) || !getline(out, s)) {
        message += "Липсва списъка с апартаменти";
        finish(1, 0, n, message);
    }

    while (s[0] == ' ') s.erase(0, 1);
    while (s.back() == ' ') s.pop_back();

    bool badSymbols = false;
    for (char c: s) {
        if (c != ' ' && !isdigit(c)) 
        {
            badSymbols = true;
        }
    }

    if (badSymbols) {
        message += "На втория ред има символ различен от интервал и цифра";
        finish(1, 0, n, message);
    }

    vector<string> tokens = getTokens(s, ' ');
    if (tokens.size() != solAns) {
        message += "Броят апартаменти е различен от броя разговори";
        finish(1, 0, n, message);
    }
    for (string& token: tokens) {
        if (!isInt(token)) {
            message += "Има невалиден номер на апартамент";
            finish(1, 0, n, message);
        }
    }

    vector<bool> apartmens(n);
    for (string& token: tokens) {
        int appartment = toInt(token);
        if (appartment < 1 || appartment > n) {
            message += "Има невалиден номер на апартамент";
            finish(1, 0, n, message);
        }
        apartmens[appartment-1] = 1;
    }

    int diff = 0;
    for (int i = 0; i < n; i++) {
        if (apartmens[i]) diff++;
    }
    if (diff < solAns) {
        message += "Има повтарящ се номер на апартамент";
        finish(1, 0, n, message);
    }

    for (int i = 0; i < n; i++) {
        if (apartmens[i]) {
            swap(v[i].first, v[i].second);
        }
    }

    for (int i = 1; i < n; i++) {
        if (v[i-1].first < v[i].first || v[i-1].second < v[i].second) {
            message += "Грешен списък с апартаменти";
            finish(1, 0, n, message);
        }
    }

    message += "Верен списък с апартаменти";
    finish(1, 1, n, message);

    return 0;
}
